Index: common/features/org.jboss.tools.common.mylyn.source.feature/build.properties
===================================================================
--- common/features/org.jboss.tools.common.mylyn.source.feature/build.properties	(revision 38411)
+++ common/features/org.jboss.tools.common.mylyn.source.feature/build.properties	(working copy)
@@ -1,3 +0,0 @@
-bin.includes = feature.xml,\
-               feature.properties,\
-               license.html
Index: common/features/org.jboss.tools.common.mylyn.source.feature/license.html
===================================================================
--- common/features/org.jboss.tools.common.mylyn.source.feature/license.html	(revision 38411)
+++ common/features/org.jboss.tools.common.mylyn.source.feature/license.html	(working copy)
@@ -1,14 +0,0 @@
-<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
-<html>
-
-<body>
-<p>Red Hat, Inc. licenses these features and plugins to you under
-certain open source licenses (or aggregations of such licenses), which
-in a particular case may include the Eclipse Public License, the GNU
-Lesser General Public License, and/or certain other open source
-licenses. For precise licensing details, consult the corresponding
-source code, or contact Red Hat Legal Affairs, 1801 Varsity Drive,
-Raleigh NC 27606 USA.
-</p>
-</body>
-</html>
\ No newline at end of file
Index: common/features/org.jboss.tools.common.mylyn.source.feature/feature.properties
===================================================================
--- common/features/org.jboss.tools.common.mylyn.source.feature/feature.properties	(revision 38411)
+++ common/features/org.jboss.tools.common.mylyn.source.feature/feature.properties	(working copy)
@@ -1,47 +0,0 @@
-###############################################################################
-# Copyright (c) 2011-2012 Red Hat, Inc. and others.
-# All rights reserved. This program and the accompanying materials 
-# are made available under the terms of the Eclipse Public License v1.0
-# which accompanies this distribution, and is available at
-# http://www.eclipse.org/legal/epl-v10.html
-# 
-# Contributors:
-#     JBoss by Red Hat - Initial implementation.
-##############################################################################
-# feature.properties
-# contains externalized strings for feature.xml
-# "%foo" in feature.xml corresponds to the key "foo" in this file
-# java.io.Properties file (ISO 8859-1 with "\" escapes)
-# This file should be translated.
-
-# "featureName" property - name of the feature
-featureName=JBoss Tools Common - Mylyn source
-featureProvider=JBoss by Red Hat
-
-# "updateSiteName" property - label for the update site
-updateSiteName=JBossTools Update Site
-
-# "description" property - description of the feature
-description=JBoss Tools Common - Mylyn plugins
-
-copyright=JBoss, Home of Professional Open Source\n\
-Copyright (c) Red Hat, Inc., and individual contributors as indicated\n\
-by the @authors tag, 2011-2012. See the copyright.txt in the distribution\n\
-for a full listing of individual contributors.
-
-# "licenseURL" property - URL of the "Feature License"
-# do not translate value - just change to point to a locale-specific HTML page
-licenseURL=license.html
-
-# START NON-TRANSLATABLE
-# "license" property - text of the "Feature Update License"
-# should be plain text version of license agreement pointed to be "licenseURL"
-license=Red Hat, Inc. licenses these features and plugins to you under \
-certain open source licenses (or aggregations of such licenses), which \
-in a particular case may include the Eclipse Public License, the GNU \
-Lesser General Public License, and/or certain other open source \
-licenses. For precise licensing details, consult the corresponding \
-source code, or contact Red Hat Legal Affairs, 1801 Varsity Drive, \
-Raleigh NC 27606 USA.
-# END NON-TRANSLATABLE
-########### end of license property ##########################################
Index: common/features/org.jboss.tools.common.mylyn.source.feature/pom.xml
===================================================================
--- common/features/org.jboss.tools.common.mylyn.source.feature/pom.xml	(revision 38411)
+++ common/features/org.jboss.tools.common.mylyn.source.feature/pom.xml	(working copy)
@@ -1,13 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
-	xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
-	<modelVersion>4.0.0</modelVersion>
-	<parent>
-		<groupId>org.jboss.tools.common</groupId>
-		<artifactId>features</artifactId>
-		<version>3.3.0-SNAPSHOT</version>
-	</parent>
-	<groupId>org.jboss.tools.common.features</groupId>
-	<artifactId>org.jboss.tools.common.mylyn.source.feature</artifactId> 
-	<packaging>eclipse-feature</packaging>
-</project>
Index: common/features/org.jboss.tools.common.mylyn.source.feature/feature.xml
===================================================================
--- common/features/org.jboss.tools.common.mylyn.source.feature/feature.xml	(revision 38411)
+++ common/features/org.jboss.tools.common.mylyn.source.feature/feature.xml	(working copy)
@@ -1,9 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<feature id="org.jboss.tools.common.mylyn.source.feature" label="%featureName" version="3.3.0.qualifier" provider-name="%featureProvider">
-
-	<description>%description</description>
-	<copyright>%copyright</copyright>
-	<license url="%licenseURL">%license</license>
-
-	<plugin id="org.jboss.tools.common.mylyn.source" download-size="0" install-size="0" version="0.0.0" />
-</feature>
Index: common/features/org.jboss.tools.common.all.feature/pom.xml
===================================================================
--- common/features/org.jboss.tools.common.all.feature/pom.xml	(revision 38411)
+++ common/features/org.jboss.tools.common.all.feature/pom.xml	(working copy)
@@ -9,4 +9,38 @@
 	<groupId>org.jboss.tools.common.features</groupId>
 	<artifactId>org.jboss.tools.common.all.feature</artifactId> 
 	<packaging>eclipse-feature</packaging>
+	
+	<build>
+		<plugins>
+			<plugin>
+		        <groupId>org.eclipse.tycho.extras</groupId>
+		        <artifactId>tycho-source-feature-plugin</artifactId>
+		        <version>${tychoVersion}</version>
+		        <executions>
+		          <execution>
+		            <id>source-feature</id>
+		            <phase>package</phase>
+		            <goals>
+		              <goal>source-feature</goal>
+		            </goals>
+		          </execution>
+		        </executions>
+		      </plugin>
+		      <plugin>
+		        <groupId>org.eclipse.tycho</groupId>
+		        <artifactId>tycho-p2-plugin</artifactId>
+		        <version>${tychoVersion}</version>
+		        <executions>
+		          <execution>
+		            <id>attached-p2-metadata</id>
+		            <phase>package</phase>
+		            <goals>
+		              <goal>p2-metadata</goal>
+		            </goals>
+		          </execution>
+		        </executions>
+		      </plugin>
+		  </plugins>
+	</build>
+	
 </project>