Index: cdi/site/pom.xml
===================================================================
--- cdi/site/pom.xml	(revision 38541)
+++ cdi/site/pom.xml	(working copy)
@@ -10,5 +10,5 @@
 	<artifactId>cdi.site</artifactId> 
 	<name>cdi.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: maven/site/pom.xml
===================================================================
--- maven/site/pom.xml	(revision 38541)
+++ maven/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>maven.site</artifactId>
 	<name>maven.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: modeshape/site/pom.xml
===================================================================
--- modeshape/site/pom.xml	(revision 38541)
+++ modeshape/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>modeshape.site</artifactId>
 	<name>modeshape.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: freemarker/site/pom.xml
===================================================================
--- freemarker/site/pom.xml	(revision 38541)
+++ freemarker/site/pom.xml	(working copy)
@@ -9,5 +9,5 @@
 	<groupId>org.jboss.tools.freemarker</groupId>
 	<artifactId>freemarker.site</artifactId> 
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: xulrunner/site/pom.xml
===================================================================
--- xulrunner/site/pom.xml	(revision 38541)
+++ xulrunner/site/pom.xml	(working copy)
@@ -10,5 +10,5 @@
 	<artifactId>xulrunner.site</artifactId>
 	<name>xulrunner.site</name> 
 	<version>1.9.2-SNAPSHOT</version>
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: gwt/site/pom.xml
===================================================================
--- gwt/site/pom.xml	(revision 38541)
+++ gwt/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>gwt.site</artifactId>
 	<name>gwt.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: portlet/site/pom.xml
===================================================================
--- portlet/site/pom.xml	(revision 38541)
+++ portlet/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>portlet.site</artifactId>
 	<name>portlet.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: hibernatetools/site/pom.xml
===================================================================
--- hibernatetools/site/pom.xml	(revision 38541)
+++ hibernatetools/site/pom.xml	(working copy)
@@ -10,5 +10,5 @@
 	<artifactId>hibernatetools.site</artifactId> 
 	<name>hibernatetools.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: forge/site/pom.xml
===================================================================
--- forge/site/pom.xml	(revision 38541)
+++ forge/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>forge.site</artifactId>
 	<name>forge.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: smooks/site/pom.xml
===================================================================
--- smooks/site/pom.xml	(revision 38541)
+++ smooks/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>smooks.site</artifactId>
 	<name>smooks.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: struts/site/pom.xml
===================================================================
--- struts/site/pom.xml	(revision 38541)
+++ struts/site/pom.xml	(working copy)
@@ -10,5 +10,5 @@
 	<artifactId>struts.site</artifactId>
 	<name>struts.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: jbpm/site/pom.xml
===================================================================
--- jbpm/site/pom.xml	(revision 38541)
+++ jbpm/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>jbpm.site</artifactId>
 	<name>jbpm.site</name>
 	<version>0.0.1-SNAPSHOT</version>
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: deltacloud/site/pom.xml
===================================================================
--- deltacloud/site/pom.xml	(revision 38541)
+++ deltacloud/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>deltacloud.site</artifactId>
 	<name>deltacloud.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: seam/site/pom.xml
===================================================================
--- seam/site/pom.xml	(revision 38541)
+++ seam/site/pom.xml	(working copy)
@@ -10,5 +10,5 @@
 	<artifactId>seam.site</artifactId>
 	<name>seam.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: archives/site/pom.xml
===================================================================
--- archives/site/pom.xml	(revision 38541)
+++ archives/site/pom.xml	(working copy)
@@ -9,5 +9,5 @@
 	<groupId>org.jboss.tools.archives</groupId>
 	<artifactId>site</artifactId>
 	<name>archives.site</name>
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: vpe/site/pom.xml
===================================================================
--- vpe/site/pom.xml	(revision 38541)
+++ vpe/site/pom.xml	(working copy)
@@ -10,5 +10,5 @@
 		<artifactId>vpe</artifactId>
 		<version>3.3.0-SNAPSHOT</version>
 	</parent>
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: tests/site/pom.xml
===================================================================
--- tests/site/pom.xml	(revision 38541)
+++ tests/site/pom.xml	(working copy)
@@ -9,5 +9,5 @@
 	<groupId>org.jboss.tools.tests</groupId>
 	<artifactId>tests.site</artifactId>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: usage/site/pom.xml
===================================================================
--- usage/site/pom.xml	(revision 38541)
+++ usage/site/pom.xml	(working copy)
@@ -10,5 +10,5 @@
 	<artifactId>usage.site</artifactId> 
 	<name>usage.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: esb/site/pom.xml
===================================================================
--- esb/site/pom.xml	(revision 38541)
+++ esb/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>esb.site</artifactId>
 	<name>esb.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: bpel/site/pom.xml
===================================================================
--- bpel/site/pom.xml	(revision 38541)
+++ bpel/site/pom.xml	(working copy)
@@ -10,7 +10,7 @@
 	<groupId>org.jboss.tools.bpel</groupId>
 	<artifactId>bpel.site</artifactId>
 	<version>0.1.0-SNAPSHOT</version>
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 	<!--
 	<repositories>
 	-->
Index: jsf/site/pom.xml
===================================================================
--- jsf/site/pom.xml	(revision 38541)
+++ jsf/site/pom.xml	(working copy)
@@ -10,5 +10,5 @@
 	<artifactId>jsf.site</artifactId>
 	<name>jsf.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: openshift/site/pom.xml
===================================================================
--- openshift/site/pom.xml	(revision 38541)
+++ openshift/site/pom.xml	(working copy)
@@ -8,5 +8,5 @@
 	</parent>
 	<groupId>org.jboss.tools.openshift</groupId>
 	<artifactId>openshift.site</artifactId> 
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: flow/site/pom.xml
===================================================================
--- flow/site/pom.xml	(revision 38541)
+++ flow/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>flow.site</artifactId>
 	<name>flow.site</name>
 	<version>0.0.1-SNAPSHOT</version>
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: common/site/pom.xml
===================================================================
--- common/site/pom.xml	(revision 38541)
+++ common/site/pom.xml	(working copy)
@@ -9,5 +9,5 @@
 	<groupId>org.jboss.tools.common</groupId>
 	<artifactId>common.site</artifactId>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: ws/site/pom.xml
===================================================================
--- ws/site/pom.xml	(revision 38541)
+++ ws/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>ws.site</artifactId>
 	<name>ws.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: jmx/site/pom.xml
===================================================================
--- jmx/site/pom.xml	(revision 38541)
+++ jmx/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>jmx.site</artifactId>
 	<name>jmx.site</name>
 	<version>1.2.0-SNAPSHOT</version>
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: examples/site/pom.xml
===================================================================
--- examples/site/pom.xml	(revision 38541)
+++ examples/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>examples.site</artifactId>
 	<name>examples.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: runtime/site/pom.xml
===================================================================
--- runtime/site/pom.xml	(revision 38541)
+++ runtime/site/pom.xml	(working copy)
@@ -11,5 +11,5 @@
 	<artifactId>runtime.site</artifactId>
 	<name>runtime.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
\ No newline at end of file
Index: jst/site/pom.xml
===================================================================
--- jst/site/pom.xml	(revision 38541)
+++ jst/site/pom.xml	(working copy)
@@ -10,5 +10,5 @@
 	<artifactId>jst.site</artifactId> 
 	<name>jst.site</name>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: birt/site/pom.xml
===================================================================
--- birt/site/pom.xml	(revision 38541)
+++ birt/site/pom.xml	(working copy)
@@ -9,5 +9,5 @@
 	<groupId>org.jboss.tools.birt</groupId>
 	<artifactId>birt.site</artifactId>
 	
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>
Index: as/site/pom.xml
===================================================================
--- as/site/pom.xml	(revision 38541)
+++ as/site/pom.xml	(working copy)
@@ -8,5 +8,5 @@
 	</parent>
 	<groupId>org.jboss.tools.as</groupId>
 	<artifactId>as.site</artifactId> 
-	<packaging>eclipse-update-site</packaging>
+	<packaging>eclipse-repository</packaging>
 </project>