### Eclipse Workspace Patch 1.0
#P org.jboss.tools.openshift.express.ui
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/NewDomainDialog.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/NewDomainDialog.java	(revision 38927)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/NewDomainDialog.java	(working copy)
@@ -20,6 +20,7 @@
 import org.jboss.tools.openshift.express.internal.ui.OpenShiftUIActivator;
 
 import com.openshift.express.client.IUser;
+import com.openshift.express.client.OpenShiftEndpointException;
 
 /**
  * @author André Dietisheim
@@ -41,9 +42,12 @@
 				protected IStatus run(IProgressMonitor monitor) {
 					try {
 						model.createDomain();
+					} catch (OpenShiftEndpointException e) {
+						return OpenShiftUIActivator.createErrorStatus(NLS.bind(
+								"Could not create domain \"{0}\": {1}", model.getNamespace(), e.getResponseResult()), e);
 					} catch (Exception e) {
-						return new Status(IStatus.ERROR, OpenShiftUIActivator.PLUGIN_ID,
-								NLS.bind("Could not create domain \"{0}\"", model.getNamespace()), e);
+						return OpenShiftUIActivator.createErrorStatus(NLS.bind(
+								"Could not create domain \"{0}\"", model.getNamespace()), e);
 					}
 					return Status.OK_STATUS;
 				}
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizard.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizard.java	(revision 38927)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizard.java	(working copy)
@@ -45,6 +45,7 @@
 import com.openshift.express.client.IApplication;
 import com.openshift.express.client.IEmbeddableCartridge;
 import com.openshift.express.client.IUser;
+import com.openshift.express.client.OpenShiftEndpointException;
 import com.openshift.express.client.OpenShiftException;
 
 /**
@@ -193,7 +194,11 @@
 							try {
 								getWizardModel().createApplication(monitor);
 								return Status.OK_STATUS;
-							} catch (Exception e) {
+							} catch (OpenShiftEndpointException e) {
+								// TODO: refresh user
+								return OpenShiftUIActivator.createErrorStatus("Could not create application \"{0}\": {1}",
+										e, applicationName, e.getResponseResult());
+							} catch (OpenShiftException e) {
 								// TODO: refresh user
 								return OpenShiftUIActivator.createErrorStatus("Could not create application \"{0}\"",
 										e, applicationName);
@@ -210,9 +215,9 @@
 	private boolean addRemoveCartridges(final IApplication application,
 			final Set<IEmbeddableCartridge> selectedCartridges) {
 		try {
+			final String applicationName = getWizardModel().getApplication().getName();
 			IStatus status = WizardUtils.runInWizard(
-					new Job(NLS.bind("Adding selected embedded cartridges for application {0}...", getWizardModel()
-							.getApplication().getName())) {
+					new Job(NLS.bind("Adding selected embedded cartridges for application {0}...", applicationName)) {
 
 						@Override
 						protected IStatus run(IProgressMonitor monitor) {
@@ -222,6 +227,10 @@
 									embeddableCartridges.addAll(selectedCartridges);
 									application.addEmbbedCartridges(embeddableCartridges);
 								}
+							} catch (OpenShiftEndpointException e) {
+								// TODO: refresh user
+								return OpenShiftUIActivator.createErrorStatus(NLS.bind(
+										"Could not embed cartridges to application {0}: {1}", applicationName, e.getResponseResult()));
 							} catch (OpenShiftException e) {
 								return OpenShiftUIActivator.createErrorStatus(NLS.bind(
 										"Could not embed cartridges to application {0}", getWizardModel()
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/EditDomainDialog.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/EditDomainDialog.java	(revision 38927)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/EditDomainDialog.java	(working copy)
@@ -15,10 +15,12 @@
 import org.eclipse.core.runtime.Status;
 import org.eclipse.core.runtime.jobs.Job;
 import org.eclipse.jface.wizard.Wizard;
+import org.eclipse.osgi.util.NLS;
 import org.jboss.tools.common.ui.WizardUtils;
 import org.jboss.tools.openshift.express.internal.ui.OpenShiftUIActivator;
 
 import com.openshift.express.client.IUser;
+import com.openshift.express.client.OpenShiftEndpointException;
 
 /**
  * @author Andre Dietisheim
@@ -47,8 +49,12 @@
 					try {
 						model.renameDomain();
 						return Status.OK_STATUS;
+					} catch(OpenShiftEndpointException e) {
+						return OpenShiftUIActivator.createErrorStatus(NLS.bind(
+								"Could not create domain \"{0}\": {1}", model.getNamespace(), e.getResponseResult()), e);
 					} catch (Exception e) {
-						return new Status(IStatus.ERROR, OpenShiftUIActivator.PLUGIN_ID, "Could not rename domain", e);
+						return OpenShiftUIActivator.createErrorStatus(NLS.bind(
+								"Could not rename domain {0}", model.getNamespace()), e);
 					}
 				}
 			}, getContainer());