### Eclipse Workspace Patch 1.0
#P org.jboss.tools.openshift.express.ui
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/ApplicationConfigurationWizardPageModel.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/ApplicationConfigurationWizardPageModel.java	(revision 39217)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/ApplicationConfigurationWizardPageModel.java	(working copy)
@@ -221,8 +221,8 @@
 			setApplicationName(application.getName());
 			setSelectedCartridge(application.getCartridge());
 			setSelectedEmbeddableCartridges(new HashSet<IEmbeddableCartridge>(application.getEmbeddedCartridges()));
+			wizardModel.setApplication(application);
 		}
-		wizardModel.setApplication(application);
 	}
 
 	public void resetExistingApplication() throws OpenShiftException {
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizard.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizard.java	(revision 39217)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizard.java	(working copy)
@@ -58,15 +58,12 @@
 
 	private OpenShiftExpressApplicationWizardModel wizardModel;
 
-	/**
-	 * @see #setUser called by CredentialsWizardPageModel#getValidityStatus
-	 */
-	public OpenShiftExpressApplicationWizard(String wizardTitle) {
-		this(null, null, null, wizardTitle);
+	public OpenShiftExpressApplicationWizard(boolean useExistingApplication, String wizardTitle) {
+		this(null, null, null, useExistingApplication, wizardTitle);
 	}
-
-	public OpenShiftExpressApplicationWizard(IUser user, IProject project, IApplication application, String wizardTitle) {
-		setWizardModel(new OpenShiftExpressApplicationWizardModel(user, project, application));
+	
+	public OpenShiftExpressApplicationWizard(IUser user, IProject project, IApplication application, boolean useExistingApplication, String wizardTitle) {
+		setWizardModel(new OpenShiftExpressApplicationWizardModel(user, project, application, useExistingApplication));
 		setWindowTitle(wizardTitle);
 		setNeedsProgressMonitor(true);
 	}
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizardModel.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizardModel.java	(revision 39229)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizardModel.java	(working copy)
@@ -44,15 +44,16 @@
 	private static final String KEY_SELECTED_EMBEDDABLE_CARTRIDGES = "selectedEmbeddableCartridges";
 
 	public OpenShiftExpressApplicationWizardModel(IUser user) {
-		this(user, null, null);
+		this(user, null, null, false);
 	}
 
-	public OpenShiftExpressApplicationWizardModel(IUser user, IProject project, IApplication application) {
+	public OpenShiftExpressApplicationWizardModel(IUser user, IProject project, IApplication application, boolean useExistingApplication) {
 		// default value(s)
 		setUser(user);
 		setProject(project);
 		setNewProject(true);
 		setApplication(application);
+		setUseExistingApplication(useExistingApplication);
 		setCreateServerAdapter(true);
 		setRepositoryPath(DEFAULT_REPOSITORY_PATH);
 		setRemoteName(NEW_PROJECT_REMOTE_NAME_DEFAULT);
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/ImportOpenShiftExpressApplicationWizard.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/ImportOpenShiftExpressApplicationWizard.java	(revision 39217)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/ImportOpenShiftExpressApplicationWizard.java	(working copy)
@@ -18,7 +18,7 @@
 	 * Constructor
 	 */
 	public ImportOpenShiftExpressApplicationWizard() {
-		super("Import OpenShift Express Application");
+		super(true, "Import OpenShift Express Application");
 	}
 
 	/**
@@ -28,6 +28,6 @@
 	 * @param application
 	 */
 	public ImportOpenShiftExpressApplicationWizard(IUser user, IProject project, IApplication application) {
-		super(user, project, application, "Import OpenShift Express Application");
+		super(user, project, application, true, "Import OpenShift Express Application");
 	}
 }
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/NewOpenShiftExpressApplicationWizard.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/NewOpenShiftExpressApplicationWizard.java	(revision 39217)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/NewOpenShiftExpressApplicationWizard.java	(working copy)
@@ -15,10 +15,10 @@
 	 * Constructor
 	 */
 	public NewOpenShiftExpressApplicationWizard() {
-		super("New OpenShift Express Application");
+		super(false, "New OpenShift Express Application");
 	}
 
 	public NewOpenShiftExpressApplicationWizard(IUser user) {
-		super(user, null, null, "New OpenShift Express Application");
+		super(user, null, null, false, "New OpenShift Express Application");
 	}
 }